#include <stdio.h>
#include <string.h>	   
#include "kernel.h"

const char AppVersion[] = "USR V0.01 #";

char dbg_msg[128];

void user_main(void *pvParameters)
{
	struct netconn *conn, *newconn;
  	err_t err;
	struct netbuf *buf;
    void *data;
    u16_t len;

	sprintf(dbg_msg, "E01 %s(%s %s)\r\n", AppVersion, __DATE__, __TIME__);
    console_write(dbg_msg);

	conn = netconn_new(NETCONN_TCP);
	if (conn == NULL) {
		sprintf(dbg_msg, "netconn_new failed:%s\r\n", lwip_strerr(err));
    	console_write(dbg_msg);
	}
	netconn_bind(conn, NULL, 4001);
	netconn_listen(conn);
	for( ;; )
	{
		err = netconn_accept(conn, &newconn);
    	if (err == ERR_OK) {	
			sprintf(dbg_msg, "%s\r\n", "accept");
    		console_write(dbg_msg);			     
      		while (1) {
	  			err = netconn_recv(newconn, &buf);
				if (err == ERR_OK) {  					
        			do {
             			netbuf_data(buf, &data, &len);
						sprintf(dbg_msg, "netconn_recv:%d\r\n", len);
						console_write(dbg_msg);
             			err = netconn_write(newconn, data, len, NETCONN_COPY);
            			if (err != ERR_OK) {
							sprintf(dbg_msg, "netconn_write:%s\r\n", lwip_strerr(err));
    						console_write(dbg_msg);
			            }
        			} while (netbuf_next(buf) >= 0);
        			netbuf_delete(buf);
      			} else {
					sprintf(dbg_msg, "%s\r\n", "close");
    				console_write(dbg_msg);	
    	  			netconn_delete(newconn);
					break;
				}			
				vTaskDelay(1);				
			}	 
		}
		vTaskDelay(1);
	}
}
