#include <stdio.h>
#include <string.h>	   
#include "kernel.h"

const char AppVersion[] = "USR V0.01 #";

char dbg_msg[128];

void user_main(void *pvParameters)
{
	int lSocket, clientfd;
	struct sockaddr_in sLocalAddr, client_addr;
    int addrlen, nbytes;
    char buffer[128];

	sprintf(dbg_msg, "E02 %s(%s %s)\r\n", AppVersion, __DATE__, __TIME__);
    console_write(dbg_msg);

	lSocket = lwip_socket(AF_INET, SOCK_STREAM, 0);
	if (lSocket < 0) {
		sprintf(dbg_msg, "%s\r\n", "socket failed");
    	console_write(dbg_msg);
		return;
	}

	memset((char *)&sLocalAddr, 0, sizeof(sLocalAddr));
	sLocalAddr.sin_family = AF_INET;
	sLocalAddr.sin_len = sizeof(sLocalAddr);
	sLocalAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	sLocalAddr.sin_port = htons(4001);

	if (lwip_bind(lSocket, (struct sockaddr *)&sLocalAddr, sizeof(sLocalAddr)) < 0) {
        lwip_close(lSocket);
		sprintf(dbg_msg, "%s\r\n", "bind failed");
    	console_write(dbg_msg);
        return;
	}

	if (lwip_listen(lSocket, 20) != 0 ){
        lwip_close(lSocket);
		sprintf(dbg_msg, "%s\r\n", "listen failed");
    	console_write(dbg_msg);
        return;
	}
	addrlen = sizeof(client_addr);
	while (1) {	 
        clientfd = lwip_accept(lSocket, (struct sockaddr*)&client_addr, (socklen_t *)&addrlen);
		sprintf(dbg_msg, "accept:%d\r\n", clientfd);
        console_write(dbg_msg);	
        if (clientfd > 0){
			sprintf(dbg_msg, "%s\r\n", "accepted");
    		console_write(dbg_msg);	
			while(1) {
               	nbytes = lwip_recv(clientfd, buffer, sizeof(buffer),0);
                if (nbytes > 0) {
					sprintf(dbg_msg, "recv:%d\r\n", nbytes);
    				console_write(dbg_msg);	
					lwip_send(clientfd, buffer, nbytes, 0);
            	} else {
					sprintf(dbg_msg, "%s\r\n", "closed");
    				console_write(dbg_msg);	
					lwip_close(clientfd);
					break;
				}
				vTaskDelay(1);
			}			               
        }
		vTaskDelay(1);
    }
}
