#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "kernel.h"

#define POST_INFO_NUM	24
extern char dbg_msg[128];
struct val_post_stuct {
    char  *name;
    char  *string;	
	char   strlen;
};
static struct val_post_stuct get_post_info[POST_INFO_NUM];

static char val_str[]={'L', 'H'};

extern struct ai_settings ai_cfg[AI_INPUT_MAX];

static unsigned short GetPostCmd(char *postdata)
{
    unsigned short idx;
	char flag;
	char *pos, *str;
	unsigned char i;

	str = postdata;

	idx = 0;
	flag = 1;
	do {
		pos = strchr(str, '=');
		if (pos == 0) {
			break;
		}
		pos[0] = 0;
		get_post_info[idx].name = str;

		str = pos + 1;
		pos = strchr(str, '&');
		if (pos == 0) {
			flag = 0;
		} else {
			pos[0] = 0;
		}
		get_post_info[idx].string = str;	
		if (flag == 0) {
			for(i=0; i<40; i++) {
				if (str[i] == 0) {
					break;
				}
			}
			get_post_info[idx].strlen = i;
		} else {
			get_post_info[idx].strlen = pos-str;
		}
		idx++;
		if (flag) {
			pos++;
			str = pos;
		}
	} while(flag && (idx < POST_INFO_NUM));

	return (idx);
}
int fetch_aicfg_value(char *ajax_buf_ptr)
{
	int len = 0;
	unsigned char i;
	unsigned char range;

	len += sprintf(&ajax_buf_ptr[len], "%s", "{\n\t\"CfgSelect\":[\n");
	for(i=0; i<AI_INPUT_MAX; i++) {
		len += sprintf(&ajax_buf_ptr[len], "\t\t{\"name\":\"en_%u\",\"val\":\"%d\"},\n", i, ai_cfg[i].enable);
		range = ai_cfg[i].range;
		if (ai_cfg[i].range != AI_RANGE_20MA) {
			range += ai_cfg[i].polar;
		} 
		len += sprintf(&ajax_buf_ptr[len], "\t\t{\"name\":\"rg_%u\",\"val\":\"%d\"}", i, range);
		if (i < (AI_INPUT_MAX-1)) {
			len += sprintf(&ajax_buf_ptr[len], "%s", ",");
		}
		len += sprintf(&ajax_buf_ptr[len], "%s", "\n");
	}
	len += sprintf(&ajax_buf_ptr[len], "%s", "\t]\n");
	len += sprintf(&ajax_buf_ptr[len], "%s", "\n}\n");
	return len;
}
int set_ctrl_ai(char *ajax_buf_ptr, char *post_data, int post_data_len)
{
	int len = 0;
	unsigned char i, post_item, idx, err=0xFF;
	unsigned short val;

	post_item = GetPostCmd(post_data);
	for(i=0; i<post_item; i++) {
		if (strlen(get_post_info[i].name) != 4) {
			len += sprintf(&ajax_buf_ptr[len], "wrong name:%s\r\n", get_post_info[i].name);
			err=1; 
			break;
		}		
		if ((strstr(get_post_info[i].name, "en_")!=0)||
		    (strstr(get_post_info[i].name, "rg_")!=0)) { 
			idx = get_post_info[i].name[3] - '0';
			if (idx >= AI_INPUT_MAX) {
				len += sprintf(&ajax_buf_ptr[len], "wrong name:%s\r\n", get_post_info[i].name); 
				err=1; 
				break;
			}
			val = strtoul(get_post_info[i].string, NULL, 10);
			if (strstr(get_post_info[i].name, "en_")!=0) {
				if (val != 0 && val != 1) {
					len += sprintf(&ajax_buf_ptr[len], "wrong value:%s=%s\r\n", get_post_info[i].name,get_post_info[i].string); 
					err=1; 
					break;
				}
				ai_cfg[idx].enable = val;
			} else if (strstr(get_post_info[i].name, "rg_")!=0) {
				if (val < AI_RANGE_20MA) {
					if ((val%2) == 0) {
						ai_cfg[idx].range = val;
						ai_cfg[idx].polar = 0;
					} else {
						ai_cfg[idx].range = val-1;
						ai_cfg[idx].polar = 1;
					}
				} else if (val == AI_RANGE_20MA) {
					ai_cfg[idx].range = val;
					ai_cfg[idx].polar = 1;
				} else {
					len += sprintf(&ajax_buf_ptr[len], "wrong value:%s=%s\r\n", get_post_info[i].name,get_post_info[i].string); 
					err=1; 
					break;
				}
			}
		} else if (strcmp(get_post_info[i].name, "save") == 0) {
			err = set_ai_settings(ai_cfg, sizeof(ai_cfg));
			//save2eeprom(1);
			//set_reset_flag(0xf8d0);
		}
	}
	if (err != 0) {
		len += sprintf(&ajax_buf_ptr[len], "Failed:%d\r\n", err);
	} else {
		len += sprintf(&ajax_buf_ptr[len], "%s", "Device reboot now.\r\nWeb will be refreshed 5 seconds later.");
		device_reboot();
	}	
	return len;
}

uint8_t show_ai_channel_value(uint8_t ai_no, char *in_str)
{
	uint8_t ret, polar_ch;	
	unsigned long value_long;
	float value_ft;
	char float_str[16];
	
	in_str[0] = 0;
	ret = ai_channel_get_value(ai_no, &value_long, &polar_ch);
	if (ret != AI_OK) {
		sprintf(dbg_msg, "ai_channel_get_value failed:%d\r\n", ret);
    	console_write(dbg_msg);
		return 0;
	}
	value_ft = ((float)value_long) / 1000;
	ftoa(value_ft, float_str, 3);
	ret = sprintf(in_str, "%c%s", polar_ch, float_str);
	return ret;
}
int fetch_all_value(char *ajax_buf_ptr)
{
	int len = 0;
	unsigned char i, val_bit, do_val;

	DO_Read(&do_val);
	len += sprintf(&ajax_buf_ptr[len], "%s", "{\"DOVal\":[");
	for(i=0; i<DO_SUM; i++) {
		val_bit = do_val&0x00000001;
		len += sprintf(&ajax_buf_ptr[len], "{\"name\":\"DO%u\",\"val\":\"%c\"}", (i+1), val_str[val_bit]);
		if (i<(DO_SUM-1)) {
			len += sprintf(&ajax_buf_ptr[len], "%s", ",");
		}
		do_val = do_val>>1;
	}
	len += sprintf(&ajax_buf_ptr[len], "%s", "],");

	len += sprintf(&ajax_buf_ptr[len], "%s", "\"AIVal\":[");
	for(i=0; i<AI_INPUT_MAX; i++) {				   		
		len += sprintf(&ajax_buf_ptr[len], "{\"id\":\"AI%u\",\"en\":\"%d\",\"val\":\"", (i+1), ai_cfg[i].enable);
		len += show_ai_channel_value((i+1), &ajax_buf_ptr[len]);
		len += sprintf(&ajax_buf_ptr[len], "%s", "\"}");
		if (i < (AI_INPUT_MAX-1)) {
			len += sprintf(&ajax_buf_ptr[len], "%s", ",");
		} 
	}
	len += sprintf(&ajax_buf_ptr[len], "%s", "]}");

	return len;
}

int fetch_do_value(char *ajax_buf_ptr)
{
	int i, len = 0, ret;
	unsigned char val_bit, do_val;

	len += sprintf(&ajax_buf_ptr[len], "{\n\t\"type\":\"%s\",\n", "DigitalOutput");
	len += sprintf(&ajax_buf_ptr[len], "\t\"action\":\"%s\",\n", "GET");

	ret = DO_Read(&do_val);

	len += sprintf(&ajax_buf_ptr[len], "%s", "\t\"response\":{\n");
	len += sprintf(&ajax_buf_ptr[len], "\t\t\"items\":%d,\n", ret);
	len += sprintf(&ajax_buf_ptr[len], "%s", "\t\t\"data\":[\n");	

	for(i=0; i<ret; i++) {
		val_bit = do_val&0x00000001;
		len += sprintf(&ajax_buf_ptr[len], "\t\t{\"key\":\"DO%u\",\"val\":\"%c\"}", (i+1), val_str[val_bit]);
		if (i<(ret-1)) {
			len += sprintf(&ajax_buf_ptr[len], "%s", ",");
		}
		len += sprintf(&ajax_buf_ptr[len], "%s", "\n");
		do_val = do_val>>1;
	}
	len += sprintf(&ajax_buf_ptr[len], "%s", "\t]}\n");
	len += sprintf(&ajax_buf_ptr[len], "%s", "}\n");
	return len;					   
}
int set_do_value(char *ajax_buf_ptr, char *post_data, unsigned short post_len)
{
	unsigned char i, post_item, idx, val;

	post_item = GetPostCmd(post_data);
	for(i=0; ((i<post_item)&&(i<DO_SUM)); i++) {
		if (strlen(get_post_info[i].name) != 3) {
			return 0;
		}		
		if ((strncmp(get_post_info[i].name, "DO", 2) != 0) || 
			((get_post_info[i].name[2] < '1') || (get_post_info[i].name[2] > '8'))){
			return 0;
		}
		idx = get_post_info[i].name[2] - '0';
		if (get_post_info[i].string[0] == 'H') {
			val = 1;
		} else if (get_post_info[i].string[0] == 'L') {
			val = 0;
		} else {
			return 0;
		}

		DO_WriteBit(idx, val);
	}
	return fetch_do_value(ajax_buf_ptr);
}

unsigned short web_file_open(char *name, char *ajax_buf_ptr, char method, char *post_data, unsigned short post_len)
{
	unsigned char cmd_type=0;

	if (strstr(name, "/wapi/v1/fetchValue") != 0) {
		cmd_type = 1;  
	} else 	if (strstr(name, "/wapi/v1/fetchAIcfg") == name) {
		cmd_type = 2;  	
	} else if (strstr(name, "/wapi/v1/CtrlDO") != 0) {
		if ((method == 1)&&(post_len > 0)) {
			cmd_type = 3;
		} 
	} else if (strcmp(name, "/wapi/v1/CfgAI") == 0) {
		if ((method == 1)&&(post_len > 0)) {
			cmd_type = 4;
		} 
	} else {
		return 0;
	} 	
	if (cmd_type == 1) {
		return (fetch_all_value(ajax_buf_ptr));
	} else if (cmd_type == 2) {
		return (fetch_aicfg_value(ajax_buf_ptr));
	} else if (cmd_type == 3) {
		return (set_do_value(ajax_buf_ptr, post_data, post_len));
	} else if (cmd_type == 4) {
		return (set_ctrl_ai(ajax_buf_ptr, post_data, post_len));
	}
	return 0;
}



