#include <stdio.h>
#include <string.h>	   
#include "kernel.h"

#define AI_CHANNEL_NO	1

const char AppVersion[] = "USR V0.01 #";

static char dbg_msg[128];

void show_ai_channel_value(void)
{
	uint8_t ret, polar_ch;	
	unsigned long value_long;
	float value_ft;
	char float_str[16];
	
	ret = ai_channel_get_value(AI_CHANNEL_NO, &value_long, &polar_ch);
	if (ret != AI_OK) {
		sprintf(dbg_msg, "ai_channel_get_value failed:%d\r\n", ret);
    	console_write(dbg_msg);
		return;
	}
	value_ft = ((float)value_long) / 1000;
	ftoa(value_ft, float_str, 3);
	sprintf(dbg_msg, "CH#%d:%c%s,%ld\r\n", AI_CHANNEL_NO, polar_ch, float_str, value_long);
    console_write(dbg_msg);
}

void user_main(void *pvParameters)
{
	sprintf(dbg_msg, "E11 AI input %s(%s %s)\r\n", AppVersion, __DATE__, __TIME__);
    console_write(dbg_msg);

	while (1) {	 
		show_ai_channel_value();
		vTaskDelay(5000);
    }
}
