#ifndef __AI_API_H__
#define __AI_API_H__

#define AI_INPUT_MAX	8

#define AI_RANGE_150MV	0x00
#define AI_RANGE_500MV	0x02
#define AI_RANGE_1V		0x04
#define AI_RANGE_5V		0x06
#define AI_RANGE_10V	0x08
#define AI_RANGE_20MA	0x0a

#define	AI_OK			0x00
#define	AI_ERR_ARG_CHENNEL_NO	0x01
#define	AI_ERR_ARG_ENABLE	0x02
#define	AI_ERR_ARG_RANGE	0x03
#define	AI_ERR_CHANNEL_DISABLE	0x04
#define	AI_ERR_CHANNEL_VALUE_NOT_READY	0x05

struct ai_settings {
	unsigned char polar; //0-Bipolar, 1-Unipolar
	unsigned char range; //150mV, 500mV, 1V, 5V, 10V, 20mA
	unsigned char enable;
};	

unsigned char ai_channel_get_value(unsigned char channel_no, unsigned long *value_long, unsigned char *polar_flag);
unsigned short get_ai_val(unsigned char ch_no, char *obuf, unsigned char max_count);
int get_ai_settings(struct ai_settings *ptr_ai_cfg, int cfg_size);
int set_ai_settings(struct ai_settings *ptr_ai_cfg, int cfg_size);

#endif
