#ifndef __SETTINGS_API_H__
#define __SETTINGS_API_H__

struct net_settings {
	char lan_cfg;	
	unsigned char lan_ip[4];
	unsigned char lan_nm[4];
	unsigned char lan_gw[4];
};	
struct serial_settings {
	char uart_mode;	
	unsigned long baud;
	char parity;
	char databits;
	char stopbits;
	char flowctl;
	unsigned short dp_vtime;
	unsigned short dp_vmin;
};	

int get_network_settings(struct net_settings *ptr_net_cfg);
int get_uart_settings(int port_no, struct serial_settings *ptr_serial_cfg);
int set_network_settings(struct net_settings *ptr_net_cfg);
int set_uart_settings(int port_no, struct serial_settings *ptr_serial_cfg);

int prg_eeprom_Open(void);
int prg_eeprom_Close(void);
int prg_eeprom_Erase(void);
//size_t prg_eeprom_WriteBlock(unsigned int addr, char *buffer, size_t size);
size_t prg_eeprom_WriteBlock(unsigned long addr, unsigned char *data_buf, unsigned short tot_len);

size_t prg_eeprom_ReadBlock(unsigned int addr, char *buffer, size_t size);

#endif
